_G.ODF = _G.ODF or {}
ODF._path = ModPath
ODF._data_path = SavePath .. "ODF_options.txt"
ODF.settings = {}
ODF.Hooks = {
    ["lib/managers/mission/elementfilter"] = "elementfilter.lua",
}

function ODF:Save()
    local file = io.open( self._data_path, "w" )
    if file then
        file:write( json.encode( self.settings ) )
        file:close()
    end
end

function ODF:Load()
    local file = io.open( self._data_path, "r" )
    if file then
        self.settings = json.decode( file:read("*all") )
        file:close()
    end
end

ODF:Load()

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_ODF", function( loc )
	for _, filename in pairs(file.GetFiles(ODF._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(ODF._path .. "loc/" .. filename)
			break
		end
	end

	loc:load_localization_file(ODF._path .. "loc/english.txt", false)
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_ODF", function( menu_manager )
	
    MenuCallbackHandler.ODF_slider = function(self, item)
        ODF.settings.ODF_slider_value = item:value() or 1
        ODF:Save()
    end

	ODF:Load()
	MenuHelper:LoadFromJsonFile( ODF._path .. "menu/options.txt", ODF, ODF.settings )
end )


function ODF:ResetToDefaultValues()
		self.settings.ODF_slider_value = 8
end

if ODF.settings.ODF_slider_value == nil
then
	ODF:ResetToDefaultValues()
end

if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if ODF.Hooks[requiredScript] then
 		dofile( ODF._path .. ODF.Hooks[requiredScript] )
	end	
end